//=============================================
// J A V A  C O M M U N I T Y  P R O C E S S
// 
// J S R  3 3 1
// 
// Common Implementation
// 
//============================================= 
package javax.constraints.impl.search.goal;

import javax.constraints.ValueSelector;
import javax.constraints.Var;
import javax.constraints.VarSelector;

public class GoalAssignValuesTimeLimit extends Goal {
	Var[] 			vars;
	VarSelector 	varSelector;
	ValueSelector 	valueSelector;
	Goal[] 			goals;
	Goal			checkGoal;

	public GoalAssignValuesTimeLimit(Var[] vars, VarSelector varSelector,
			ValueSelector valueSelector) {
		super(vars[0].getProblem().getSolver(), "AssignValuesWithTimeLimit");
		this.vars = vars;
		this.varSelector = varSelector;
		this.valueSelector = valueSelector;
		goals = new Goal[vars.length];
		for (int i = 0; i < vars.length; i++) {
			goals[i] = new GoalAssignValueTimeLimit(vars[i], valueSelector);
		}
		checkGoal = new GoalCheckTimeLimit(getSolver());
	}

	public Goal execute() throws Exception {
		trace();
		int index = varSelector.select();
		boolean timeLimitViolated = getSolver().checkTimeLimit();
		if (index == -1 || timeLimitViolated) {
			return checkGoal; // if time limit is violated some vars would not be bound
		}
		return goals[index].and(checkGoal).and(this);
	}
}
