package org.jcp.jsr331.samples;

import javax.constraints.*;

// Generated by Kathryn Glenn Francis <k.francis@pgrad.unimelb.edu.au>

public class Example {

	public static void main(String[] args) {
		Problem csp = ProblemFactory.newProblem("example");
		Var corn = csp.variable("corn", 0, 7);
		Var wheat = csp.variable("wheat", 0, 7);
		
		Constraint c = csp.linear(corn, "<", 3);
		csp.post(c.negation());
		csp.postLinear(corn.plus(wheat), "<=", 7);
		
		Var objective = corn.multiply(3).plus(wheat.multiply(4));
		objective.setName("objective");
		csp.add(objective);
		
		Solver solver = csp.getSolver();
		Solution solution = solver.findOptimalSolution(Objective.MAXIMIZE, objective);
		System.out.println("Solution: "+solution.getValue("corn") + " corn, " + solution.getValue("wheat") + " wheat"
				+ ", objective=" + solution.getValue("objective"));
	}

}